=== debian/changelog ===
simtrace2 (0.5.2) UNRELEASED; urgency=medium

  * adapt to host tools in autotools

 -- Harald Welte <lafore@gnumonks.org>  Thu, 28 Nov 2019 00:44:57 +0100

simtrace2 (0.5.1) unstable; urgency=medium

  * Backwards-compatibility with older (released, non-master) libosmocore

 -- Harald Welte <lafore@gnumonks.org>  Sun, 26 Aug 2018 11:50:36 +0200

simtrace2 (0.5) unstable; urgency=medium

  * Initial debian package release.

 -- Harald Welte <lafore@gnumonks.org>  Sun, 26 Aug 2018 10:37:19 +0200
