=== debian/changelog ===
simtrace2 (0.7.0) UNRELEASED; urgency=medium

  * adapt to host tools in autotools
  * Snapshot build

 -- Harald Welte <lafore@gnumonks.org>  Wed, 11 Dec 2019 01:36:32 +0000
