=== firmware/apps/cardem/Makefile ===
C_FILES += $(C_LIBUSB_RT)

C_FILES += card_emu.c cciddriver.c iso7816_4.c iso7816_fidi.c mitm.c mode_cardemu.c mode_ccid.c simtrace_iso7816.c sniffer.c tc_etu.c usb.c
