=== debian/changelog ===
simtrace2 (0.7.0.49.baa6) UNRELEASED; urgency=medium

  * adapt to host tools in autotools
  * Snapshot build

 -- Harald Welte <lafore@gnumonks.org>  Thu, 06 Feb 2020 02:03:10 +0000
