=== debian/control ===
--- 
+++ 
@@ -1,8 +1,8 @@
 Source: simtrace2
-Maintainer: Harald Welte <laforge@gnumonks.org>
+Maintainer: Osmocom team <openbsc@lists.osmocom.org>
 Section: devel
 Priority: optional
-Build-Depends: debhelper (>= 9),
+Build-Depends: debhelper (>= 10),
                autotools-dev,
                autoconf,
                automake,
@@ -10,14 +10,14 @@
                pkg-config,
                git,
                dh-autoreconf,
-               libosmocore-dev,
+               libosmocore-dev (>= 1.4.0),
                libpcsclite-dev,
                libnewlib-arm-none-eabi,
                libusb-1.0-0-dev,
                gcc-arm-none-eabi
 Standards-Version: 3.9.8
-Vcs-Git: git://git.osmocom.org/simtrace2.git
-Vcs-Browser: http://git.osmocom.org/simtrace2/
+Vcs-Git: https://gitea.osmocom.org/sim-card/simtrace2
+Vcs-Browser: https://gitea.osmocom.org/sim-card/simtrace2
 Homepage: http://osmocom.org/projects/simtrace2/wiki
 
 Package: simtrace2-firmware
@@ -33,15 +33,15 @@
 Section: devel
 Architecture: any
 Multi-Arch: same
-Depends: osmocom-nightly, ${shlibs:Depends}, ${misc:Depends}, libosmo-simtrace2-0
+Depends: osmocom-nightly (= 202312152026), ${shlibs:Depends}, ${misc:Depends}, libosmo-simtrace2-1
 Recommends: simtrace2-firmware
 Description: Host utilities to communicate with SIMtrace2 USB Devices.
 
-Package: libosmo-simtrace2-0
+Package: libosmo-simtrace2-1
 Section: libs
 Architecture: any
 Multi-Arch: same
-Depends: osmocom-nightly, ${shlibs:Depends}, ${misc:Depends}
+Depends: osmocom-nightly (= 202312152026), ${shlibs:Depends}, ${misc:Depends}
 Description: Osmocom SIMtrace2 library
   This library contains core "driver" functionality to interface with the
   Osmocom SIMtrace2 (and compatible) USB device firmware.  It enables
@@ -52,7 +52,7 @@
 Section: libdevel
 Architecture: any
 Multi-Arch: same
-Depends: osmocom-nightly, libosmo-simtrace2-0, ${misc:Depends}
+Depends: osmocom-nightly (= 202312152026), libosmo-simtrace2-1, ${misc:Depends}
 Description: Development headers for Osmocom SIMtrace2 library
   This library contains core "driver" functionality to interface with the
   Osmocom SIMtrace2 (and compatible) USB device firmware.  It enables
