## simtrace2 0.8.1.66.e6e7.202312182026

=== debian/changelog ===
simtrace2 (0.8.1.66.e6e7.202312182026) unstable; urgency=medium

  * Automatically generated changelog entry for building the Osmocom nightly feed

 -- Osmocom OBS scripts <info@osmocom.org>  Mon, 18 Dec 2023 20:27:07 +0000
