## simtrace2 0.8.1.66.e6e7.202312242026

=== debian/changelog ===
simtrace2 (0.8.1.66.e6e7.202312242026) unstable; urgency=medium

  * Automatically generated changelog entry for building the Osmocom nightly feed

 -- Osmocom OBS scripts <info@osmocom.org>  Sun, 24 Dec 2023 20:27:08 +0000
