## simtrace2 0.8.1.66.e6e7.202312262026

=== debian/changelog ===
simtrace2 (0.8.1.66.e6e7.202312262026) unstable; urgency=medium

  * Automatically generated changelog entry for building the Osmocom nightly feed

 -- Osmocom OBS scripts <info@osmocom.org>  Tue, 26 Dec 2023 20:27:11 +0000
