## simtrace2 0.8.1.66.e6e7.202312272026

=== debian/changelog ===
simtrace2 (0.8.1.66.e6e7.202312272026) unstable; urgency=medium

  * Automatically generated changelog entry for building the Osmocom nightly feed

 -- Osmocom OBS scripts <info@osmocom.org>  Wed, 27 Dec 2023 20:27:07 +0000
