## simtrace2 0.8.1.66.e6e7.202312282026

=== debian/changelog ===
simtrace2 (0.8.1.66.e6e7.202312282026) unstable; urgency=medium

  * Automatically generated changelog entry for building the Osmocom nightly feed

 -- Osmocom OBS scripts <info@osmocom.org>  Thu, 28 Dec 2023 20:27:10 +0000
